package comunicacao.data;

import java.util.Hashtable;
import java.util.Vector;

import comunicacao.data.segment.SequenceNumber;

public class WindowClient {
	private int windowSize;
	private Hashtable<SequenceNumber, Boolean> window;
	private SequenceNumber base;
	private SequenceNumber end;

	public WindowClient(SequenceNumber base, int windowSize){
		this.windowSize = windowSize;
		this.window = new Hashtable<SequenceNumber, Boolean>(100);
		this.base = base;
		this.end = new  SequenceNumber(base.value() + windowSize);
		
	}
	
	
	public boolean isDuplicated(SequenceNumber number) {
		if (number.value() < base.value()) {
			return true;
		} else {
			return window.containsKey(number);
		}
	}

	public boolean packetReceived(SequenceNumber packetNumber, int length) {
		if (packetNumber.value() < base.value() || packetNumber.value() > end.value()) {
			return false;
		} else {

			if (!window.containsKey(packetNumber)) {
				window.put(packetNumber, true);
				
				while (window.containsKey(base)){
					window.remove(base);
					base.add(length);
					end.add(length);
				}
			
			}
			return true;
		}
	}

}
