package core;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Random;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import userManagement.User;

import comunicacao.IServerSocket;
import comunicacao.ISocket;
import comunicacao.TCPServerSocket;

public class ActionServer extends ProgramServer implements Runnable {
	private ISocket socket;
	private ArrayList<ReciveCommand> threads;
	private User user;
	private boolean active;
	public ActionServer(ISocket socket) throws IOException {
		this.active = true;
		this.socket = socket;
		this.threads = new ArrayList<ReciveCommand>();
	}

	public void run() {
		try {
			ExecutorService serverThread = Executors.newCachedThreadPool();
			while (this.active) {
				String command = (String) socket.readObject();
				if (command.equals("registerUser")) {
					socket.sendObject(registerUser((String) socket.readObject(),
							(String) socket.readObject(), (String) socket.readObject()));
					break;
				} else if (command.equals("verifyUser")) {
					this.user = verifyUser((String) socket.readObject(), (String) socket.readObject());
					if (user != null) {
						socket.sendObject(true);
						socket.sendObject(user);
					}
					else{
						socket.sendObject(false);
						break;
					}
				} else if (command.equals("desconect")) {
					break;
				} else {
					boolean ok = false;
					int port = 0;
					Random random = new Random();
					IServerSocket serverSocket = null;
					while(!ok){
						try{
							port = random.nextInt(65535) + 1;
							serverSocket = new TCPServerSocket(port);
							ok = true;
						} catch (Exception e){
							ok = false;
						}
					}
					socket.sendObject(port);
					ReciveCommand reciveCommand = new ReciveCommand(
							serverSocket, command);
					threads.add(reciveCommand);
					serverThread.submit(reciveCommand);
				}
			}
			socket.close();
			this.active = false;
		} catch (Exception e) {

		}
	}

	@Override
	public void desconect() {
		this.active = false;
		
	}
	
	public ArrayList<InformationCliente> getInformationClientes(){
		
		ArrayList<InformationCliente> informationClientes = new ArrayList<InformationCliente>();
		for (int i = 0; i < threads.size(); i++) {
			if(threads.get(i).isActive()){
				informationClientes.add(threads.get(i).getInformationCliente());
			}
			else{
				threads.remove(i--);
			}
		}
		return informationClientes;
	}
	
	public ISocket getSocket() {
		return socket;
	}

	public boolean isActive() {
		return active;
	}

	public User getUser() {
		return user;
	}
	
	
	
}
