package core;
import java.io.File;
import java.io.IOException;

import userManagement.User;

import comunicacao.IServerSocket;
import comunicacao.ISocket;

public class ReciveCommand extends ProgramServer implements Runnable {
	private IServerSocket serverSocket;
	private String command;
	private boolean active;
	private GetInformationsClient getInformationsClient;

	public ReciveCommand(IServerSocket serverSocket, String command) {
		this.getInformationsClient = null;
		this.serverSocket = serverSocket;
		this.command = command;
		active = true;
	}

	public void run() {
		try {
			ISocket socket = serverSocket.accept();
			User user = (User) socket.readObject();
			String address = (String) socket.readObject();
			if (command.equals("putFile")) {
				this.getInformationsClient = new GetInformationsClient(socket, user, new File(address), 'U');
				File file = socket.readFile();
				System.out.println("Usuario: " + user + "Endereco: "
						+ address + "\nPath name: "
						+ file.getPath()+"\nEh um arquivo.");
				putFile(user, address, file);
			} else if (command.equals("putDirectory")) {
				System.out.println("Usuario: " + user + "Endereco: "
						+ address +"\nEh um diretorio.");
				putDirectory(user, address);
			} else {
				delete(user, address);
			}
			socket.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		this.getInformationsClient.desconecte();
		active = false;
	}

	public InformationCliente getInformationCliente(){
		if(getInformationsClient != null){
				return getInformationsClient.getInformationCliente();
		}
		else{
			return null;
		}
	}
	
	public boolean isActive() {
		return active;
	}

	@Override
	public void desconect() {
		// TODO Auto-generated method stub

	}
}
