package core;
import java.io.File;
import java.io.IOException;
import java.net.InetAddress;
import java.net.UnknownHostException;

import userManagement.User;

import comunicacao.ISocket;
import comunicacao.TCPSocket;

public class SendingCommand extends Thread {
	private String ip;
	private int port;
	private String command;
	private User user;
	private String address;
	private File file;
	private GetInformationsClient getInformationsClient;
	private boolean active;
	

	public SendingCommand(String ip, int port, String command, User user,
			String address, File file) {
		this.getInformationsClient = null;
		this.ip = ip;
		this.port = port;
		this.command = command;
		this.user = user;
		this.address = address;
		this.file = file;
		this.active = true;
	}
	public SendingCommand(String ip, int port, String command, User user,
			String address) {
		this.ip = ip;
		this.port = port;
		this.command = command;
		this.user = user;
		this.address = address;
	}


	public void run() {
		while(true){
			try {
				ISocket socket = new TCPSocket(InetAddress.getByName(ip), port);
				socket.sendObject(user);
				socket.sendObject(address);
				if (command.equals("putFile")) {
					getInformationsClient = new GetInformationsClient(socket,user,file,'D');
					while(!file.canRead()){
						Thread.yield();
					}
					socket.sendFile(file);
				}
				socket.close();
				Thread.sleep(10000);
				break;
			} catch (UnknownHostException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		this.getInformationsClient.desconecte();
		this.active = false;
	}
	
	public InformationCliente getInformationCliente(){
		if(getInformationsClient != null){
				return getInformationsClient.getInformationCliente();
		}
		else{
			return null;
		}
	}
	public boolean isActive() {
		return active;
	}
	
	
}
