package core;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.Arrays;
import java.util.Scanner;

import userManagement.User;


public class Verifier extends Thread {

	private File status = new File("status.txt");
	private Scanner statusInput;
	private BufferedWriter temp;
	private String fileName = "";
	private long fileLastModified = 0;
	private ClienteOut clienteOut;
	private String addressYamBox;
	private boolean active;
	
	public Verifier(User user, String addressYamBox, ProgramServer programServer){
		this.clienteOut = new ClienteOut (user,programServer);
		this.addressYamBox = addressYamBox;
	} 
	
	public void run(){
		try {
			int i = 0;
			this.active = true;
			while(this.active){
				System.out.println(i++);
				Thread.sleep(500);
				verifier();
			}
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		this.clienteOut.desconecte();
	}
	
	public void verifier() throws IOException{
		try {
			temp = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(new File("temp.txt"))));
			//threadOut = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(new File("threadOut.txt"))));
			if(!status.exists()){
				status.createNewFile();
			}
			statusInput = new Scanner(status);
			//Scanner sharedFilesInput;
			//sharedFilesInput = new Scanner(sharedFiles);
			//while(sharedFilesInput.hasNext()){
				File fileTemp = new File(addressYamBox);
				//System.out.println(fileTemp.getName());
				if(fileTemp.exists()){
					//printTemp(fileTemp);
					File[] fileTempArray = {fileTemp};
					list(fileTempArray);
				}
				else{
					//Avisar que o arquivo compartilhado nao existe mais.
				}
			//}
			while(statusInput.hasNext()){
				fileName = statusInput.nextLine();
				fileLastModified = statusInput.nextLong();
				statusInput.nextLine();
				printErro(fileName,"Deletar");
			}
		} catch (FileNotFoundException e) {
			// O arquivo de pastas compartilhadas no existe
			e.printStackTrace();
		}
		statusInput.close();
		if(status.delete()){
			temp.close();
			//threadOut.close();
			(new File("temp.txt")).renameTo(status);
		}
		
	}
	public boolean list(File[] files) throws IOException{
		Arrays.sort(files);
		boolean statusOk = true;
		boolean actualOk = false;
		for (int i = 0; i < files.length; i++) {
			while(!actualOk){
				//System.out.println(files[i].getPath());
				if(statusOk){
					if(statusInput.hasNext()){
						fileName = statusInput.nextLine();
						fileLastModified = statusInput.nextLong();
						statusInput.nextLine();
					}
					else{
						listAndSend(files,i);	
						return true;
					}
				}
				//System.out.println(files[i].getPath()+" "+fileName);
				if(files[i].getPath().equals(fileName)){
						if(files[i].lastModified() != fileLastModified && files[i].isFile()){
							printErro(files[i],"Enviar");
						}
						printTemp(files[i]);
						statusOk = true;
						actualOk = true;
				}
				else if(files[i].getPath().compareTo(fileName) > 0){
					printErro(fileName,"Deletar");
					statusOk = true;
					actualOk = false;
				}
				else{
					printTemp(files[i]);
					printErro(files[i],"Enviar");
					statusOk = false;
					actualOk = true;
				}
				
			}
			actualOk = false;
			if(files[i].isDirectory()){
				list(files[i].listFiles());
			}
		}
		return true;
	}
	
	public void listAndSend(File[] files,int i) throws IOException{
		Arrays.sort(files);
		for (; i < files.length; i++) {
			printTemp(files[i]);
			printErro(files[i],"Enviar");
			if(files[i].isDirectory()){
				listAndSend(files[i].listFiles(),0);
			}
		}
	}
	public void printTemp(File file) throws IOException{
		//System.out.println(file.getPath());
		temp.write(file.getPath()+"\r\n"+file.lastModified()+"\r\n");
	}
	public void printErro(String file,String command) throws IOException{
		//System.out.println(file.getPath());
		//threadOut.write(type+": "+file+"\r\n");
		clienteOut.sendComand(new File(file), command);
	}
	public void printErro(File file,String command) throws IOException{
		//System.out.println(file.getPath());
		//threadOut.write(type+": "+file.getPath()+"\r\n");
		clienteOut.sendComand(file, command);
	}
	
	public void desconecte(){
		this.active = false;
		this.clienteOut.desconecte();
	}
}
